.486
.model flat, stdcall
option casemap: none

; API functions
; ************************************
include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\gdi32.inc 
include \masm32\include\comctl32.inc
include \masm32\include\masm32.inc

includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\gdi32.lib 
includelib \masm32\lib\comctl32.lib
includelib \masm32\lib\masm32.lib

include	    \masm32\macros\macros.asm



; Prototype 
; ************************************
DialogProc   PROTO : HWND, : UINT, : WPARAM, : LPARAM
TranspWindow PROTO :DWORD,:DWORD

.const

; Resource ids
; ************************************
IDD_DLG1  	  equ 101
IDI_ICON      equ 200
IDC_EXIT      equ 102
IDC_STC1      equ 150
TRANSPARENT_VALUE	equ 210
; ************************************



; Required data

.data
szTitle       TCHAR "Transparent window 3", 0

.data?
hInstance HINSTANCE ?
hIcon     HICON     ?
hBrush1			 dd ?
hr				HRGN ?
hr0				HRGN ?
.code

start:
invoke GetModuleHandle, NULL
mov hInstance, eax

invoke LoadIcon, eax, IDI_ICON 
mov hIcon, eax
; ************************************
;   Call the dialog box stored in resource file
; ************************************
invoke DialogBoxParam, hInstance, IDD_DLG1 , NULL, ADDR DialogProc, 0
invoke ExitProcess, 0


; Dialog procedure
; ************************************
DialogProc proc hWnd: HWND, uMsg: UINT, wParam: WPARAM, lParam: LPARAM

local rc:RECT

 .if uMsg == WM_INITDIALOG

invoke SetWindowText, hWnd, addr szTitle 
invoke SendMessage, hWnd, WM_SETICON,ICON_SMALL, hIcon
invoke CreateRectRgn,40,60,170,155
mov hr0,eax
invoke GetWindowRect,hWnd,addr rc
mov eax,rc.right
mov ecx,rc.bottom
sub eax,rc.left
sub ecx,rc.top
invoke CreateRectRgn,0,0,eax,ecx
mov hr,eax
invoke CombineRgn,hr,hr,hr0,RGN_XOR		

invoke TranspWindow,hr0,TRANSPARENT_VALUE
;invoke SetWindowRgn,hWnd,hr0,

    .elseif uMsg == WM_COMMAND

.elseif uMsg==WM_CTLCOLORSTATIC
invoke GetWindowLong,lParam,GWL_ID
.if eax==IDC_STC1  		
.if hBrush1
invoke DeleteObject,hBrush1
.endif
invoke CreateSolidBrush,00FFFFFFh
mov		hBrush1,eax
ret
.endif
.elseif uMsg == WM_CLOSE
invoke EndDialog, hWnd, 0
 .endif
.if wParam == IDC_EXIT 
invoke SendMessage, hWnd, WM_CLOSE, 0, 0
.endif

    xor eax,eax
  ret
DialogProc endp
; TranspWindow procedure
; ************************************
TranspWindow proc _dialoghandle:dword,_value:dword
	
	pushad
	
	invoke GetModuleHandle,chr$("user32.dll")
	invoke GetProcAddress,eax,chr$("SetLayeredWindowAttributes")
	.if eax!=0
		;---yes, its win2k/xp system---
		mov edi,eax
		invoke GetWindowLong,_dialoghandle,GWL_EXSTYLE	;get EXSTYLE
		
		.if _value==255
			xor eax,WS_EX_LAYERED	;remove WS_EX_LAYERED
		.else
			or eax,WS_EX_LAYERED	;eax = oldstlye + new style(WS_EX_LAYERED)
		.endif
		
		invoke SetWindowLong,_dialoghandle,GWL_EXSTYLE,eax
		
		.if _value<255
			push LWA_ALPHA
			push _value						;set level of transparency
			push 0							;transparent color
			push _dialoghandle					;window handle
			call edi						;call SetLayeredWindowAttributes
		.endif	
	.endif
	
	popad
	ret
TranspWindow endp
end start